PostgreSQL 8.4.7 Documentation
Prev | Fast Backward |  | Fast Forward | Next

# SPI_cursor_open

## Name

SPI_cursor_open -- set up a cursor using a plan created with `SPI_prepare`

## Synopsis

    Portal SPI_cursor_open(const char * name, SPIPlanPtr plan,
                           Datum * values, const char * nulls,
                           bool read_only)

## Description

`SPI_cursor_open` sets up a cursor (internally, a portal) that will execute a plan prepared by `SPI_prepare`. The parameters have the same meanings as the corresponding parameters to `SPI_execute_plan`.

Using a cursor instead of executing the plan directly has two benefits. First, the result rows can be retrieved a few at a time, avoiding memory overrun for queries that return many rows. Second, a portal can outlive the current procedure (it can, in fact, live to the end of the current transaction). Returning the portal name to the procedure's caller provides a way of returning a row set as result.

The passed-in data will be copied into the cursor's portal, so it can be freed while the cursor still exists.

## Arguments

`const char * `name``

  name for portal, or `NULL` to let the system select a name

`SPIPlanPtr `plan``

  execution plan (returned by `SPI_prepare`)

`Datum * `values``

  An array of actual parameter values. Must have same length as the plan's number of arguments.

`const char * `nulls``

  An array describing which parameters are null. Must have same length as the plan's number of arguments. `n` indicates a null value (entry in `values` will be ignored); a space indicates a nonnull value (entry in `values` is valid).

  If `nulls` is `NULL` then `SPI_cursor_open` assumes that no parameters are null.

`bool `read_only``

  `true` for read-only execution

## Return Value

Pointer to portal containing the cursor. Note there is no error return convention; any error will be reported via `elog`.

Prev | Home | Next
SPI_execp | Up | SPI_cursor_open_with_args